;==================================================================
;
;                          resini.scm
;
;                   Gandalf version c-2.5
;
;    
;  Top-level initialisation for compiled version only.
;  
;  Other files: resbase.scm
;              (basic operations, incl subst. unif. and subsumption)
;               resio.scm
;
;====================================================================
 


;;;;;;;;; *********************************************************

(define user-interrupt quit)

; top-level-actions calls the prover with command line arguments
; interpreted as problem file names, instead of reading these
; as scheme source and entering top level loop.

(define (top-level-actions)  
  (verbose 0)
  (let ((filename '()))
    (cond
      ; no input
      ((or (null? (program-arguments))
	    (null? (cdr (program-arguments))) )	
	  (newline)
	  (display "No input files given")
	  (newline)
	  (quit) )
      ; try to show satisfiability	  
      ((and (not (null? (cddr (program-arguments))))	  
            (equal? "-sat" (cadr (program-arguments))) )
          (set! filename (caddr (program-arguments)))  
          (display "Gandalf v. c-2.5 starting to show satisfiability: ")
	  (display filename)
	  (newline)
	  (set! *sat-strategy-flag* #t) 
	  (set! *full-proof-strategy-flag* #f)
	  (fprove filename) )
      ((and (not (null? (cddr (program-arguments))))	  
            (equal? "-proof" (cadr (program-arguments))) )
          (set! filename (caddr (program-arguments)))  
          (display "Gandalf v. c-2.5 starting to prove (full proof mode): ")
	  (display filename)
	  (newline)
	  (set! *sat-strategy-flag* #f) 
	  (set! *full-proof-strategy-flag* #t)
	  (fprove filename) )  
      ; refute            
      (else         
      	  (set! filename (cadr (program-arguments)))
	  (newline)
	  ; (display "*******************************************")
	  ; (newline)
	  (display "Gandalf v. c-2.5 starting to prove: ")
	  (display filename)
	  (newline)
	  (set! *sat-strategy-flag* #f) 
	  (set! *full-proof-strategy-flag* #f)
	  (fprove filename)
    	  (newline)
	  (quit) ))))

; the following call always exits the whole program

; (top-level-actions)
